//No jets, no fall damage, regenerating health, lower jump, (slightly) more air control
//OHKO'd by a Pong projectile - like the Energy Balls in Portal

datablock PlayerData(PlayerPortal : PlayerStandardArmor)
{
	maxDamage = 1;
	maxEnergy = 60;
	canJet = 0;
	rechargeRate = 0.1;
	airControl = 0.2;
	upmaxspeed = 500;
	jumpforce = PlayerStandardArmor.jumpforce * 0.67;
	speedDamagescale = 0;
	uiName = "Portal-Style Player";
	showEnergyBar = true;
	groundimpactminspeed = 0;
	groundimpactshakeamp = "0.1 0.1 0.1";
};

function PlayerPortal::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
 if(%damageType $= $DamageType::Fall || %damagetype $= $Damagetype::groundFall){return;}

 %flash = %obj.getDamageFlash() + ((%damage / %this.maxEnergy) * 2);
 if (%flash > 0.75)
  %flash = 0.75;
  %obj.setDamageFlash(%flash);

 %curEnergy = %obj.getEnergyLevel();
 if(%damage >= %curEnergy)
 {
  %obj.setEnergyLevel(0);
  %damage = 1;
 }
 else
 {
  %obj.setEnergyLevel(%curEnergy - %damage);
  %damage = 0;
 }
 Parent::damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
 if(%obj.getEnergyLevel() < 40)
 {
  %obj.emote(painMidImage,1);
 }
 if(%obj.getEnergyLevel() < 15)
 {
  %obj.emote(painHighImage,1);
 }
}

%error = forceRequiredAddOn("Projectile_Pong");
if(%error == $Error::AddOn_Disabled)
{
 PongProjectile.uiName = "";
 return;
}

if(%error == $Error::AddOn_NotFound)
{
 error("ERROR: Player_Portal - Required Add-On Projectile_Pong not found.");
 return;
}

AddDamageType("Pong",   '<bitmap:add-ons/player_portal/CI_pong> %1', '%2 <bitmap:add-ons/Player_Portal/CI_pong> %1',0.2,1);

function pongProjectile::onCollision(%this,%obj,%col,%pos,%normal,%fade)
{
 Parent::onCollision(%this,%obj,%col,%pos,%normal,%fade);
 if((%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer") && %col.getDatablock().getName() $= "PlayerPortal")
 {
  PlayerPortal::Damage(PlayerPortal, %col, %obj.sourceObject, %pos, PlayerPortal.maxEnergy+1, $DamageType::Pong);
 }
}